//
//  ========================================================================
//  Copyright (c) 1995-2017 Mort Bay Consulting Pty. Ltd.
//  ------------------------------------------------------------------------
//  All rights reserved. This program and the accompanying materials
//  are made available under the terms of the Eclipse Public License v1.0
//  and Apache License v2.0 which accompanies this distribution.
//
//      The Eclipse Public License is available at
//      http://www.eclipse.org/legal/epl-v10.html
//
//      The Apache License v2.0 is available at
//      http://www.opensource.org/licenses/apache2.0.php
//
//  You may elect to redistribute this code under either of these licenses.
//  ========================================================================
//

package org.eclipse.jetty.client;

import java.io.Closeable;

import org.eclipse.jetty.client.api.Connection;

public interface ConnectionPool extends Closeable
{
    boolean isActive(Connection connection);

    boolean isEmpty();

    boolean isClosed();

    Connection acquire();

    boolean release(Connection connection);

    boolean remove(Connection connection);

    @Override
    void close();
}
